#include <plib.h>
#include <p32xxxx.h>

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1
// Disabld WDT , ICSP/ICD = PGC4 , PGD4
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx4

#define SystemFrequency		60000000L

int main(void)
{
    unsigned int i = 0;

    // Disable the JTAG function
    DDPCONbits.JTAGEN = 0;

    // 使用C32的SYSTEM Config巨集將CPU的操作最佳化，但不修改到FPBDIV的設定。
    SYSTEMConfig(SystemFrequency, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
    // SYSTEMConfigPerformance( SystemFrequency  );
    // SYSTEMConfigWaitStates( SystemFrequency );

    INTEnableSystemMultiVectoredInt();

    // 使用C32 I/O Prot Function將LED對應之I/O 設定成數位輸出，並指定I/O Port狀態。
    mPORTASetPinsDigitalOut(BIT_9);
    mPORTCSetPinsDigitalOut(BIT_3);
    mPORTAClearBits(BIT_9);
    mPORTCSetBits(BIT_3);

    while (1)
    {
        // 改變LED狀態。
        mPORTAToggleBits(BIT_9);
        mPORTCToggleBits(BIT_3);

        //  完成延遲副程式，使LED變化可以被人眼所察覺。
        // (嘗試使用軟體模擬中的Stopwatch功能來計算延遲時間)
        for (i = 0; i < 3333331; i++);
    }

    while (1);
}
